#pragma once

namespace FileMan {
 using namespace System;
 using namespace System::ComponentModel;
 using namespace System::Collections;
 using namespace System::Windows::Forms;
 using namespace System::Data;
 using namespace System::Drawing;
 	
 public ref class Form1 : public System::Windows::Forms::Form {
 public:
 Form1(void)	{
  InitializeComponent();
  GetListFS();
 }

 protected:
 ~Form1() {
  if (components) {
   delete components;
  }
 }
 private: System::Windows::Forms::ListView^  listViewFiles;
 protected: 
 private: System::Windows::Forms::ImageList^  imageList1;
 private: System::Windows::Forms::Label^  filePathLabel;
 private: System::Windows::Forms::Button^  button1;
 private: System::ComponentModel::IContainer^  components;

 private:
#pragma region Windows Form Designer generated code
 void InitializeComponent(void)	{
	 this->components = (gcnew System::ComponentModel::Container());
	 System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
	 this->listViewFiles = (gcnew System::Windows::Forms::ListView());
	 this->imageList1 = (gcnew System::Windows::Forms::ImageList(this->components));
	 this->filePathLabel = (gcnew System::Windows::Forms::Label());
	 this->button1 = (gcnew System::Windows::Forms::Button());
	 this->SuspendLayout();
	 // 
	 // listViewFiles
	 // 
	 this->listViewFiles->LargeImageList = this->imageList1;
	 this->listViewFiles->Location = System::Drawing::Point(12, 47);
	 this->listViewFiles->Name = L"listViewFiles";
	 this->listViewFiles->Size = System::Drawing::Size(521, 135);
	 this->listViewFiles->TabIndex = 0;
	 this->listViewFiles->UseCompatibleStateImageBehavior = false;
	 this->listViewFiles->ItemActivate += gcnew System::EventHandler(this, &Form1::listViewFiles_ItemActivate);
	 // 
	 // imageList1
	 // 
	 this->imageList1->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"imageList1.ImageStream")));
	 this->imageList1->TransparentColor = System::Drawing::Color::Transparent;
	 this->imageList1->Images->SetKeyName(0, L"file.png");
	 this->imageList1->Images->SetKeyName(1, L"copy.png");
	 this->imageList1->Images->SetKeyName(2, L"disc.png");
	 // 
	 // filePathLabel
	 // 
	 this->filePathLabel->AutoSize = true;
	 this->filePathLabel->Location = System::Drawing::Point(12, 185);
	 this->filePathLabel->Name = L"filePathLabel";
	 this->filePathLabel->Size = System::Drawing::Size(35, 13);
	 this->filePathLabel->TabIndex = 1;
	 this->filePathLabel->Text = L"label1";
	 // 
	 // button1
	 // 
	 this->button1->Location = System::Drawing::Point(18, 15);
	 this->button1->Name = L"button1";
	 this->button1->Size = System::Drawing::Size(67, 21);
	 this->button1->TabIndex = 2;
	 this->button1->Text = L"Up!";
	 this->button1->UseVisualStyleBackColor = true;
	 this->button1->Click += gcnew System::EventHandler(this, &Form1::button1_Click);
	 // 
	 // Form1
	 // 
	 this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
	 this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
	 this->ClientSize = System::Drawing::Size(547, 291);
	 this->Controls->Add(this->button1);
	 this->Controls->Add(this->filePathLabel);
	 this->Controls->Add(this->listViewFiles);
	 this->Name = L"Form1";
	 this->Text = L"Form1";
	 this->ResumeLayout(false);
	 this->PerformLayout();

 }
#pragma endregion
 public: static String ^PathToFile = "";
 public: void GetListFS()      {
  // () 
  listViewFiles->BeginUpdate();
  listViewFiles->Items->Clear();
  if (PathToFile == "") { //   , ...
                          //   
   array <String ^> ^ strDrives = System::Environment::GetLogicalDrives();
   for each (String ^ strDrive in strDrives) {
	listViewFiles->Items->Add(strDrive, 2); 
   }
  }
  else  {
   try {
    //  
    array <String ^> ^ dirs = System::IO::Directory::GetDirectories(PathToFile);
    for each (String ^ s in dirs) {
     String ^ dirname = System::IO::Path::GetFileName(s);
     listViewFiles->Items->Add(dirname, 1);
    }
    //  
    array<String^> ^ files = System::IO::Directory::GetFiles(PathToFile, "*.*", System::IO::SearchOption::AllDirectories);
    for each (String ^ s in files) {
     String ^ filename = System::IO::Path::GetFileName(s);
     listViewFiles->Items->Add(filename, 0);
    }
   }
   catch  (...) {
    MessageBox::Show("Error", "", MessageBoxButtons::OK);
	return;
   }
  }
  //       
  filePathLabel->Text = PathToFile;
  // 
  listViewFiles->EndUpdate();
 }

 private: System::Void listViewFiles_ItemActivate(System::Object^  sender, System::EventArgs^  e) {
  if (listViewFiles->SelectedItems->Count == 0) return;
  ListViewItem ^ item = listViewFiles->SelectedItems[0];
  switch (item->ImageIndex) {
   case 1: {
    PathToFile += "\\" + item->Text;
    GetListFS();
    break;
   }               
   default: {
    PathToFile += item->Text;
    GetListFS();
    break;
   }
  }
 }
			 
 private: System::Void button1_Click(System::Object^  sender, System::EventArgs^  e) {
  System::IO::DirectoryInfo ^ dirinfo;
  try {
   dirinfo = System::IO::Directory::GetParent(PathToFile);
   PathToFile = dirinfo->ToString();
  }
  catch (...) {
   PathToFile = ""; 
  }
  GetListFS();
 }

 };
}

